;main.asm
;********************************************************************
;	VGA  30   51   16  + FLASH
;	 :	 
;	: 		PIC18F46K20
;********************************************************************

        PROCESSOR 18F46K20
        #include <P18F46K20.INC>
        #include "def.inc"

	;   
        ORG     0x0000
        nop
        goto    start
        
        ; 
        ORG     0x0008
        #include "interrupt.asm"

;********************************************************************
;	  
;********************************************************************
	
	ORG	0x0500
start:
	; 
	call	CPU_init

        ;  
        call    draw_demo_screen  

  	;    SPI 
        movlw   high CMD_JUMP_TABLE
        movwf   PCLATH

        ;  
        clrf    TMR2
        bsf     INTCON, GIEH
        bcf     INTCON, GIEL

	;   4 
	; CRT    
	;-  .
demo_loop:
	btfss	flash_counter, 7
        bra     demo_loop

	;  
        call    clear_video_memory

	;----------------------------------------
	;  
	;----------------------------------------

	;  
main:
        bcf     bByteReceived
	#ifdef MODE_I2C
	bcf	SSPCON1, SSPOV
        bsf	SSPCON1, CKP
	#endif
	
	;  
main_loop:
        btfss   bByteReceived
        bra     main_loop

	#ifdef MODE_I2C
        btfss	SSPSTAT, D_NOT_A        ; 
        bra	main
	#endif

        ;  
        movlw   0xE0
        andwf   CMD_Temp, w
        bz      command_received
        
        call	WORK_OUT_SYMBOL		; 
        bra	main
        
command_received:
	call	WORK_NEW_COMMAND	; 
	bra	main

;********************************************************************

	; 
	org	0x0600
	#include "subs.asm"
	
	;
        ORG	0x1000
        #include "font.asm"

	; 
	ORG	0x3000
	#include "demo.asm"
	
;********************************************************************
        END
